︠6c66c11a-18cf-4a0e-ad1a-6566aa0e0255︠
#####################################################################
##                                                                 ##
## Distribution Statistique des Distances entre Antisites Voisins  ##
##                                                                 ##
#####################################################################
︡67f2d4cc-6f8c-46b9-ba26-0fd95d8dfd7c︡︡
︠7751cd1e-9d95-4853-831c-1c31e1bb2751︠
#Variables : 
    #r : distance entre sites, 
    #N : 0.22 nm^-3
    #p : probabilite d'avoir la distance r
    #rmax : distance la plus probable
r,N,p,rmax= var('r N p rmax')
︡5b6f2cb9-2495-4bc8-9aff-b0b8e5621539︡︡
︠f62b012d-9bcd-42b7-b844-e7ecf9c9bcf5︠
p(r,N)=4*pi*r^2*N*exp(-N*4*pi*r^3/3)
p(r,N)
︡a87e4d17-d64e-49af-8e41-8823920eff53︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}4 \\, \\pi N r^{2} e^{-4/3*pi*N*r^3}</span>"}︡
︠5464f68e-14d0-45cb-8bab-a1c6be812d1b︠
graph=plot(p(r,0.22),r,0,3)
graph.show()
︡f1fd1818-df22-4519-ae03-7856e916fb51︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠b3615cc5-6104-415a-98de-cc1502a28aa5︠
#Distribution des distances entre antisites voisins dans CLN (en nm)
#Maximum atteint à rmax=0.898 nm avec une largeurà mi-hauteur de 0.84507 nm (voir plus bas)
︡89e91922-b128-4961-b668-cd59b5a5f0f0︡︡
︠977b9768-fdc7-4eb3-aa76-341e7f82b25b︠
#Recherche des max de la courbe
solve(diff(p(r,N),r),r)
︡a5cc1824-068e-437d-9736-6d425e7e8a30︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}[\nr == 1/4*(I*sqrt(3) - 1)*2^(2/3)/(pi^(1/3)*N^(1/3)),\nr == 1/4*(-I*sqrt(3) - 1)*2^(2/3)/(pi^(1/3)*N^(1/3)),\nr == 1/2*2^(2/3)/(pi^(1/3)*N^(1/3)),\nr == 0\n]</span>"}︡
︠842614df-5d9b-4169-a472-2a4623a8d883︠
#valeur rmax de la distance la plus probable retenue (réelle et positive)
rmax=1/(2^(1/3)*pi^(1/3)*N^(1/3))

#valeur numérique en nm
rmaxPhy=1/(2^(1/3)*pi^(1/3)*0.22^(1/3))
n(rmaxPhy)
︡f1b259dc-f966-44f7-9824-edb57ffc1ae1︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0.897702601202902</span>"}︡
︠88e4aa89-6a2b-442b-939f-aa6cff15f179︠
# Valeur de la probabilité à mi hauteur pour évaluer la largeur a mi hauteur
pdemi=p(rmaxPhy,0.22)/2
n(pdemi)
︡530ddc06-e9c2-41c7-ab55-4df0e03d21c3︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0.571923394612675</span>"}︡
︠bf36d4c4-33ff-4269-b7b3-6a849e69c164︠
# Recherche des distances pour lesquelles p(r)=pdemi
# Avec la méthode de Newton, on cherche les zéros de la fonction :
︡29ba35df-4222-4794-9570-488a2f833259︡︡
︠99785f63-5466-48f9-9adc-8972c2d3a26d︠
p(r,N)-pdemi
︡8417c3d0-2df1-4e2b-be00-78d2767dcc5e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}4 \\, \\pi N r^{2} e^{-4/3*pi*N*r^3} - 0.603681073679769 \\, \\pi^{\\left(\\frac{1}{3}\\right)} 2^{\\left(\\frac{1}{3}\\right)} e^{-0.666666666666667}</span>"}︡
︠6a506c1f-47bc-4d2c-8bd5-307d2f4cd7b4︠
diff(4*pi*r^2*N*e^(-(4*pi*r^3*N/3)) - 0.619880395326*pi^(1/3)/2^(2/3),r)
︡bbf5c604-f2e6-41b6-801b-7c1b720e878c︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-16 \\, \\pi^{2} N^{2} r^{4} e^{-4/3*pi*N*r^3} + 8 \\, \\pi N r e^{-4/3*pi*N*r^3}</span>"}︡
︠c49e0af6-996a-4e1b-a37a-26240f364075︠
def R2(R):
    return 4*pi*R^2*0.22*e^(-(4*pi*R^3*0.22/3)) - 0.619880395326*pi^(1/3)/2^(2/3)
def dR2(R):
    return n(8*pi*R*0.22*e^(-(4*pi*R^3*0.22/3)) - 16*pi^2*R^4*0.22^2*e^(-(4*pi*R^3*0.22/3)))
def Phi(x):
    return n(x-R2(x)/dR2(x))

def Newton(depart):
    R1=depart
    R3=0
    err=2
    tour=0
    while (err>0.0001 and tour<10000):
        R3=Phi(R1)
        err=abs(R3-R1)
        R1=R3
        tour=tour+1
    if tour==10000:
        return I
    else:
        return R1
︡c8538dcc-5c1b-4db5-a8d7-ed751e5c7a13︡︡
︠7acbff4d-11a1-4e7b-9e78-cfad4c8df5c3︠
#Calcul de la largeur à mi hauteur de p :
rdemi2=Newton(1)#premier point
rdemi1=Newton(0.2)#second point
sigma=abs(rdemi2-rdemi1)
sigma
︡622cb34b-4051-48af-921e-b363de17bd79︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0.845078226562872</span>"}︡
